source: common/common-functions@ 7432834

2.3 2.3.x 2.4 ablfs ablfs-more legacy new_features trunk
Last change on this file since 7432834 was 7432834, checked in by George Boudreau <georgeb@…>, 18 years ago

Begin coding against the CLFS-2.0 book

  • Property mode set to 100644
File size: 29.1 KB
Line 
1#!/bin/bash
2
3# $Id$
4
5set +e
6
7# VT100 colors
8declare -r BLACK=$'\e[1;30m'
9declare -r DK_GRAY=$'\e[0;30m'
10
11declare -r RED=$'\e[31m'
12declare -r GREEN=$'\e[32m'
13declare -r YELLOW=$'\e[33m'
14declare -r BLUE=$'\e[34m'
15declare -r MAGENTA=$'\e[35m'
16declare -r CYAN=$'\e[36m'
17declare -r WHITE=$'\e[37m'
18
19declare -r OFF=$'\e[0m'
20declare -r BOLD=$'\e[1m'
21declare -r REVERSE=$'\e[7m'
22declare -r HIDDEN=$'\e[8m'
23
24declare -r tab_=$'\t'
25declare -r nl_=$'\n'
26
27declare -r DD_BORDER="${BOLD}==============================================================================${OFF}"
28declare -r SD_BORDER="${BOLD}------------------------------------------------------------------------------${OFF}"
29declare -r STAR_BORDER="${BOLD}******************************************************************************${OFF}"
30
31# bold yellow > < pair
32declare -r R_arrow=$'\e[1;33m>\e[0m'
33declare -r L_arrow=$'\e[1;33m<\e[0m'
34
35
36usage() {
37cat <<- -EOF-
38${DD_BORDER}
39${BOLD}
40 Usage: $0 ${BOLD}[OPTION]
41
42${RED}IMPORTANT:${OFF} Only supported command line switches are listed here.
43 For more fine-grained setups you must edit the relevant
44 configuration files placed under ${BOLD}common/${OFF} and ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])/${OFF}
45
46Options:
47${BOLD} -h, --help${OFF}
48 print this help, then exit
49
50${BOLD} -V, --version${OFF}
51 print version information, then exit
52
53${BOLD} -B, --book VER${OFF}
54 use VER version of the book as the system to build.
55 Supported VER values are:
56 dev*, trunk, SVN = aliases for the Development version of {C,H}LFS
57 branch-NAME = a branch of name NAME
58 VERSION = the version of a stable released book
59 To know what branches and stable books works with this version of jhalfs
60 please see http://wiki.linuxfromscratch.org/alfs/wiki/SupportedBooks
61
62${BOLD} -D --directory DIR${OFF}
63 use DIR directory for building ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF}; all files jhalfs produces
64 will be in the directory DIR/${SCRIPT_ROOT}.
65 The current setting for BUILDDIR is "$BUILDDIR"
66
67${BOLD} -G, --get-packages${OFF}
68 download the packages and patches. This assumes that the server declared
69 in the configuration file has the proper packages and patches for the
70 book version being processed.
71
72${BOLD} -O, --optimize${OFF}
73 Optimize [0-2]
74 0 = no optimization
75 1 = optimize final system only
76 2 = optimize both temporary tools and final system
77 Edit common/opt_config{,.d/*} and common/opt_override as desired.
78
79${BOLD} -T, --testsuites N ${OFF}
80 Run test suites [0-3]
81 0 = none
82 1 = only final system Glibc, GCC and Binutils testsuites
83 2 = all final system testsuites
84 3 = all temporary tools and final system testsuites
85 In CLFS, 3 is an alias to 2
86
87${BOLD} -W, --working-copy DIR${OFF}
88 use the local working copy placed in DIR as the $(echo $PROGNAME | tr [a-z] [A-Z]) book
89
90${BOLD} -C, --comparasion TYPE${OFF}
91 do iterative comparison analysis. This extends the total build time
92 considerably because the entire final system will rebuild itself
93 the number of times specified by ITERATIONS in common/config.
94 Types allowed are:
95 ICA = do ICA as designed by Greg Schafer
96 farce = do the farce analysis designed by Ken Moffat
97 both = perfom both ICA and farce analysis
98
99${BOLD} -F, --fstab FILE${OFF}
100 use FILE as the /etc/fstab file for the ${BOLD}$(echo $PROGNAME | tr [a-z] [A-Z])${OFF} system. If not specified,
101 a default /etc/fstab file with dummy values is created.
102
103${BOLD} -K, --kernel-config FILE${OFF}
104 use the kernel configuration file specified in FILE to build the kernel.
105 if the file is not found, or if not specified, the kernel build is skipped.
106
107${BOLD} -M, --run-make${OFF}
108 run make on the generated Makefile
109
110${BOLD} -R --rebuild${OFF}
111 clean the build directory before perfoming any other task. The directory
112 is cleaned only if it was populated by a previous jhalfs run.
113-EOF-
114
115[[ ${PROGNAME} = "clfs" ]] &&
116cat <<- -EOF-
117
118${BOLD} -A, --arch ARCH ${OFF}
119 Select the TARGET architecture, valid selections are:
120 32bit builds
121 x86, i486, i586, ppc, mips, mipsel, sparc
122 64bit builds
123 x86_64-64, mips64-64, mipsel64-64, sparc64-64, alpha
124 64bit multi-lib
125 x86_64, mips64, mipsel64, sparc64, ppc64
126
127${BOLD} --boot-config FILE ${OFF}
128 The configuration file for the bootstrap kernel if method=boot
129
130${BOLD} --method BUILDMETHOD ${OFF}
131 Select the build method, chroot or boot
132-EOF-
133
134[[ ${PROGNAME} = "clfs2" ]] &&
135cat <<- -EOF-
136
137${BOLD} -A, --arch ARCH ${OFF}
138 Select the TARGET architecture, valid selections are:
139 32bit builds
140 arm
141 64bit builds
142
143 64bit multi-lib
144-EOF-
145
146[[ ${PROGNAME} = "hlfs" ]] &&
147cat <<- -EOF-
148
149${BOLD} --model STYLE ${OFF}
150 Select the library model for the HLFS system
151 Valid choices are: glibc or uclibc
152-EOF-
153
154cat <<- -EOF-
155${DD_BORDER}
156-EOF-
157 exit
158}
159
160version="
161${BOLD} \"jhalfs\"${OFF} builder tool (development) \$Rev$
162\$Date$
163
164${BOLD} \"${PROGNAME}\"${OFF} script module
165
166Written by George Boudreau,
167 Manuel Canales Esparcia,
168 Jeremy Huntwork
169
170This program is published under the ${BOLD}Gnu General Public License, Version 2.${OFF}
171"
172
173
174no_empty_builddir() {
175 'clear'
176cat <<- -EOF-
177${DD_BORDER}
178
179${tab_}${tab_}${BOLD}${RED}W A R N I N G${OFF}
180 Looks like the \$BUILDDIR directory contains subdirectories
181 from a previous HLFS build.
182
183 Please format the partition mounted on \$BUILDDIR or set
184 a different build directory before running jhalfs.
185${OFF}
186${DD_BORDER}
187-EOF-
188 exit
189}
190
191
192help="${nl_}Try '$0 --help' for more information."
193
194exit_missing_arg="\
195echo \"Option '\$1' requires an argument\" >&2
196echo \"\$help\" >&2
197exit 1"
198
199HEADER="# This file is automatically generated by jhalfs
200# DO NOT EDIT THIS FILE MANUALLY
201#
202# Generated on `date \"+%F %X %Z\"`"
203
204
205
206#----------------------------------#
207wrt_target() { # Create target and initialize log file
208#----------------------------------#
209 local i=$1
210 local PREV=$2
211 case $i in
212 iteration* ) local LOGFILE=$this_script.log ;;
213 * ) local LOGFILE=$this_script ;;
214 esac
215(
216cat << EOF
217
218$i: $PREV
219 @\$(call echo_message, Building)
220 @./progress_bar.sh \$@ &
221 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >logs/$LOGFILE
222EOF
223) >> $MKFILE.tmp
224}
225
226
227#----------------------------------#
228wrt_target_boot() { # Create target and initialize log file
229#----------------------------------#
230 local i=$1
231 local PREV=$2
232 case $i in
233 iteration* ) local LOGFILE=$this_script.log ;;
234 * ) local LOGFILE=$this_script ;;
235 esac
236(
237cat << EOF
238
239$i: $PREV
240 @\$(call echo_message, Building)
241 @./progress_bar.sh \$@ &
242 @echo -e "\n\`date\`\n\nKB: \`du -skx --exclude=${SCRIPT_ROOT}\`\n" >logs/$LOGFILE
243EOF
244) >> $MKFILE.tmp
245}
246
247#----------------------------#
248get_package_tarball_name() { #
249#----------------------------#
250 local script_name=$1
251
252 # The use of 'head' is necessary to limit the return value to the FIRST match..
253 # hopefully this will not cause problems.
254 #
255 case $script_name in
256 tcl) echo $(grep "^tcl" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
257 *) echo $(grep "^$script_name-[[:digit:]]" $JHALFSDIR/pkg_tarball_list | head -n1 ) ;;
258 esac
259
260}
261
262#----------------------------------#
263wrt_remove_existing_dirs() { #
264#----------------------------------#
265 local PKG_NAME=$1
266(
267cat << EOF
268 @PKG_PATH=\`ls -t \$(MOUNT_PT)\$(SRC)/${PKG_NAME} | head -n1\` && \\
269 ROOT=\`tar -tf \$\$PKG_PATH | head -n1 | sed -e 's@^./@@;s@/.*@@'\` && \\
270 [[ -n \$\$ROOT ]] && \\
271 rm -rf \$(MOUNT_PT)\$(SRC)/\$\$ROOT && \\
272 if [ -e \$(MOUNT_PT)\$(SRC)/${PKG_NAME%-*}-build ]; then \\
273 rm -rf \$(MOUNT_PT)\$(SRC)/${PKG_NAME%-*}-build; \\
274 fi;
275EOF
276) >> $MKFILE.tmp
277}
278
279#----------------------------------#
280wrt_remove_existing_dirs2() { #
281#----------------------------------#
282 local PKG_NAME=$1
283(
284cat << EOF
285 @PKG_PATH=\`ls -t \$(SRC)/${PKG_NAME} | head -n1\` && \\
286 ROOT=\`tar -tf \$\$PKG_PATH | head -n1 | sed -e 's@^./@@;s@/.*@@'\` && \\
287 [[ -n \$\$ROOT ]] && \\
288 rm -rf \$(SRC)/\$\$ROOT && \\
289 if [ -e \$(SRC)/${PKG_NAME%-*}-build ]; then \\
290 rm -rf \$(SRC)/${PKG_NAME%-*}-build; \\
291 fi;
292EOF
293) >> $MKFILE.tmp
294}
295
296
297
298#----------------------------------#
299wrt_unpack() { # Unpack and set 'ROOT' var
300#----------------------------------#
301 local FILE=$1
302 local optSAVE_PREVIOUS=$2
303
304 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
305 wrt_remove_existing_dirs "$FILE"
306 fi
307(
308cat << EOF
309 @\$(call unpack,$FILE)
310 @ROOT=\`head -n1 \$(MOUNT_PT)\$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
311 echo "export PKGDIR=\$(MOUNT_PT)\$(SRC)/\$\$ROOT" > envars && \\
312 chown -R lfs \$(MOUNT_PT)\$(SRC)/\$\$ROOT
313EOF
314) >> $MKFILE.tmp
315}
316
317
318#----------------------------------#
319wrt_unpack_clfs() { # Unpack and set 'ROOT' var
320#----------------------------------#
321 local FILE=$1
322 local optSAVE_PREVIOUS=$2
323
324 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
325 wrt_remove_existing_dirs "$FILE"
326 fi
327(
328cat << EOF
329 @\$(call unpack,$FILE)
330 @ROOT=\`head -n1 \$(MOUNT_PT)\$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
331 echo "export PKGDIR=\$(MOUNT_PT)\$(SRC)/\$\$ROOT" > envars && \\
332 chown -R clfs \$(MOUNT_PT)\$(SRC)/\$\$ROOT
333EOF
334) >> $MKFILE.tmp
335}
336
337
338#----------------------------------#
339wrt_unpack2() { #
340#----------------------------------#
341 local FILE=$1
342 local optSAVE_PREVIOUS=$2
343
344 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
345 wrt_remove_existing_dirs "$FILE"
346 fi
347(
348cat << EOF
349 @\$(call unpack2,$FILE)
350 @ROOT=\`head -n1 \$(MOUNT_PT)\$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
351 echo "export PKGDIR=\$(SRC)/\$\$ROOT" > envars
352EOF
353) >> $MKFILE.tmp
354}
355
356
357#----------------------------------#
358wrt_unpack3() { #
359#----------------------------------#
360 local FILE=$1
361 local optSAVE_PREVIOUS=$2
362
363 if [ "${optSAVE_PREVIOUS}" != "1" ]; then
364 wrt_remove_existing_dirs2 "$FILE"
365 fi
366(
367cat << EOF
368 @\$(call unpack3,$FILE)
369 @ROOT=\`head -n1 \$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
370 echo "export PKGDIR=\$(SRC)/\$\$ROOT" > envars
371EOF
372) >> $MKFILE.tmp
373}
374
375#----------------------------------#
376wrt_test_log() { # Initialize testsuite log file
377#----------------------------------#
378 local TESTLOGFILE=$1
379(
380cat << EOF
381 @echo "export TEST_LOG=$TESTLOGDIR/$TESTLOGFILE" >> envars && \\
382 su - lfs -c "echo -e '\n\`date\`\n' >$TESTLOGDIR/$TESTLOGFILE"
383EOF
384) >> $MKFILE.tmp
385}
386
387#----------------------------------#
388wrt_test_log2() { #
389#----------------------------------#
390 local TESTLOGFILE=$1
391(
392cat << EOF
393 @echo "export TEST_LOG=/$SCRIPT_ROOT/test-logs/$TESTLOGFILE" >> envars && \\
394 echo -e "\n\`date\`\n" >test-logs/$TESTLOGFILE
395EOF
396) >> $MKFILE.tmp
397}
398
399#----------------------------------#
400wrt_target_vars() { # Target vars for hlfs (cross-build method)
401#----------------------------------#
402(
403cat << EOF
404 @echo "export target=$(uname -m)-${TARGET}" >> envars && \\
405 echo "export ldso=/lib/${LOADER}" >> envars
406EOF
407) >> $MKFILE.tmp
408
409}
410
411
412#----------------------------------#
413wrt_run_as_su() { # Execute script inside time { }, footer to log file
414#----------------------------------#
415 local this_script=$1
416 local file=$2
417(
418cat << EOF
419 @( time { su - lfs -c "source /home/lfs/.bashrc && $JHALFSDIR/${PROGNAME}-commands/$file" >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
420 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
421EOF
422) >> $MKFILE.tmp
423}
424
425
426#----------------------------------#
427wrt_run_as_root() { # Some scripts must be run as root..
428#----------------------------------#
429 local this_script=$1
430 local file=$2
431(
432cat << EOF
433 @( time { export LFS=\$(MOUNT_PT) && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
434 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
435EOF
436) >> $MKFILE.tmp
437}
438
439
440#----------------------------------#
441wrt_run_as_clfs_su() { # Execute script inside time { }, footer to log file
442#----------------------------------#
443 local this_script=$1
444 local file=$2
445(
446cat << EOF
447 @( time { su - clfs -c "source /home/clfs/.bashrc && $JHALFSDIR/${PROGNAME}-commands/$file" >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
448 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
449EOF
450) >> $MKFILE.tmp
451}
452
453
454#----------------------------------#
455wrt_run_as_clfs_root() { # Some scripts must be run as root..
456#----------------------------------#
457 local this_script=$1
458 local file=$2
459(
460cat << EOF
461 @( time { export CLFS=\$(MOUNT_PT) && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
462 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/$this_script
463EOF
464) >> $MKFILE.tmp
465}
466
467
468#----------------------------------#
469wrt_run_as_root2() { #
470#----------------------------------#
471 local this_script=$1
472 local file=$2
473(
474cat << EOF
475 @( time { source envars && ${PROGNAME}-commands/$file >>logs/$this_script 2>&1 ; } ) 2>>logs/$this_script && \\
476 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \`\n" >>logs/$this_script
477EOF
478) >> $MKFILE.tmp
479}
480
481
482
483#----------------------------------#
484wrt_run_as_chroot1() { #
485#----------------------------------#
486 local this_script=$1
487 local file=$2
488(
489 cat << EOF
490 @( time { \$(CHROOT1) 'cd /${SCRIPT_ROOT} && source envars && /${SCRIPT_ROOT}/${PROGNAME}-commands/$file >>/${SCRIPT_ROOT}/logs/${this_script} 2>&1' ; } ) 2>>logs/$this_script && \\
491 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/${this_script}
492EOF
493) >> $MKFILE.tmp
494}
495
496
497#----------------------------------#
498wrt_run_as_chroot2() { #
499#----------------------------------#
500 local this_script=$1
501 local file=$2
502(
503cat << EOF
504 @( time { \$(CHROOT2) 'cd /${SCRIPT_ROOT} && source envars && /${SCRIPT_ROOT}/${PROGNAME}-commands/$file >>/${SCRIPT_ROOT}/logs/${this_script} 2>&1' ; } ) 2>>logs/$this_script && \\
505 echo -e "\nKB: \`du -skx --exclude=${SCRIPT_ROOT} \$(MOUNT_PT)\`\n" >>logs/${this_script}
506EOF
507) >> $MKFILE.tmp
508}
509
510
511#----------------------------------#
512wrt_copy_fstab() { #
513#----------------------------------#
514 local i=$1
515(
516 cat << EOF
517 @cp -v $FSTAB \$(MOUNT_PT)/etc/fstab >>logs/$i 2>&1
518EOF
519) >> $MKFILE.tmp
520}
521
522#----------------------------------#
523wrt_copy_fstab2() { #
524#----------------------------------#
525 local i=$1
526(
527 cat << EOF
528 @cp -v /sources/fstab /etc/fstab >>logs/$i 2>&1
529EOF
530) >> $MKFILE.tmp
531}
532
533
534#----------------------------------#
535wrt_remove_build_dirs() { #
536#----------------------------------#
537 local name=$1
538(
539cat << EOF
540 @ROOT=\`head -n1 \$(MOUNT_PT)\$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
541 rm -r \$(MOUNT_PT)\$(SRC)/\$\$ROOT && \\
542 if [ -e \$(MOUNT_PT)\$(SRC)/$name-build ]; then \\
543 rm -r \$(MOUNT_PT)\$(SRC)/$name-build; \\
544 fi;
545EOF
546) >> $MKFILE.tmp
547}
548
549
550#----------------------------------#
551wrt_remove_build_dirs2() { #
552#----------------------------------#
553 local name=$1
554(
555cat << EOF
556 @ROOT=\`head -n1 \$(SRC)/\$(PKG_LST) | sed 's@^./@@;s@/.*@@'\` && \\
557 rm -r \$(SRC)/\$\$ROOT && \\
558 if [ -e \$(SRC)/$name-build ]; then \\
559 rm -r \$(SRC)/$name-build; \\
560 fi;
561EOF
562) >> $MKFILE.tmp
563}
564
565
566#----------------------------------#
567wrt_touch() { #
568#----------------------------------#
569(
570cat << EOF
571 @touch \$@ && \\
572 sleep .25 && \\
573 echo -e "\n\n "\$(BOLD)Target \$(BLUE)\$@ \$(BOLD)OK && \\
574 echo --------------------------------------------------------------------------------\$(WHITE)
575EOF
576) >> $MKFILE.tmp
577}
578
579
580#----------------------------------#
581wrt_report() { #
582#----------------------------------#
583(
584cat << EOF
585
586create-sbu_du-report: $PREV
587 @\$(call echo_message, Building)
588 @./create-sbu_du-report.sh logs $VERSION
589 @\$(call echo_report,$VERSION-SBU_DU-$(date --iso-8601).report)
590 @touch \$@
591EOF
592) >> $MKFILE.tmp
593
594chapter789="$chapter789 create-sbu_du-report"
595}
596
597
598#----------------------------#
599run_make() { #
600#----------------------------#
601 # Test if make must be run.
602 if [ "$RUNMAKE" = "1" ] ; then
603 # Test to make sure we're running the build as root
604 if [ "$UID" != "0" ] ; then
605 echo "You must be logged in as root to successfully build the system."
606 exit 1
607 fi
608 # Build the system
609 if [ -e $MKFILE ] ; then
610 echo -ne "Building the system...\n"
611 cd $JHALFSDIR && make
612 echo -ne "done\n"
613 fi
614 fi
615}
616
617
618#----------------------------#
619clean_builddir() { #
620#----------------------------#
621 # Test if the clean must be done.
622 if [ "$CLEAN" = "1" ] ; then
623 # Test to make sure we're running the clean as root
624 if [ "$UID" != "0" ] ; then
625 echo "You must be logged in as root to clean the build directory."
626 exit 1
627 fi
628 # Test to make sure that the build directory was populated by jhalfs
629 if [ ! -d $JHALFSDIR ] || [ ! -d $BUILDDIR/sources ] ; then
630 echo "Looks like $BUILDDIR was not populated by a previous jhalfs run."
631 exit 1
632 else
633 # Clean the build directory
634 echo -ne "Cleaning $BUILDDIR...\n"
635 rm -rf $BUILDDIR/{bin,boot,dev,etc,home,lib,media,mnt,opt,proc,root,sbin,srv,sys,tmp,tools,cross-tools,usr,var}
636 echo -ne "Cleaning $JHALFSDIR...\n"
637 rm -rf $JHALFSDIR/{0*,1*,envars,sources-dir,*commands,*logs,Makefile,*.xsl,makefile-functions,pkg_tarball_list,*.config,*.sh}
638 echo -ne "Cleaning remainig extracted sources in $BUILDDIR/sources...\n"
639 rm -rf `find $BUILDDIR/sources/* -maxdepth 0 -type d`
640 echo -ne "done\n"
641 fi
642 fi
643}
644
645#----------------------------#
646get_book() { #
647#----------------------------#
648 cd $JHALFSDIR
649
650 if [ -z $WC ] ; then
651 # Check for Subversion instead of just letting the script hit 'svn' and fail.
652 test `type -p svn` || eval "echo \"This feature requires Subversion.\"
653 exit 1"
654 echo -n "Downloading the $PROGNAME document, $LFSVRS version... "
655
656 case $PROGNAME in
657 lfs) svn_root="LFS" ;;
658 hlfs) svn_root="HLFS" ;;
659 clfs) svn_root="cross-lfs" ;;
660 clfs2) svn_root="cross-lfs" ;;
661 *) echo "BOOK not defined in function <get_book>"
662 exit 1 ;;
663 esac
664 # Grab a fresh book if it's missing, otherwise, update it from the
665 # repo. If we've already extracted the commands, move on to getting the
666 # sources.
667 if [ -d ${PROGNAME}-$LFSVRS ] ; then
668 cd ${PROGNAME}-$LFSVRS
669 if LC_ALL=C svn up | grep -q At && \
670 test -d $JHALFSDIR/${PROGNAME}-commands && \
671 test -f $JHALFSDIR/pkg_tarball_list ; then
672 # Set the canonical book version
673 echo -ne "done\n"
674 cd $JHALFSDIR
675 case $PROGNAME in
676 clfs | clfs2)
677 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
678 *)
679 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
680 esac
681 get_sources
682 else
683 echo -ne "done\n"
684 extract_commands
685 fi
686 else
687 case $PROGNAME in
688 clfs2 ) svn co $SVN/${svn_root}/branches/clfs-2.0/BOOK ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1 ;;
689 *) svn co $SVN/${svn_root}/${TREE} ${PROGNAME}-$LFSVRS >>$LOGDIR/$LOG 2>&1 ;;
690 esac
691 echo -ne "done\n"
692 extract_commands
693 fi
694
695 else
696 echo -ne "Using $BOOK as book's sources ...\n"
697 extract_commands
698 fi
699 echo -ne " Document version ${L_arrow}${BOLD}${VERSION}${R_arrow}\n"
700}
701
702#----------------------------#
703extract_commands() { #
704#----------------------------#
705
706 # Check for libxslt instead of just letting the script hit 'xsltproc' and fail.
707 test `type -p xsltproc` || eval "echo \"This feature requires libxslt.\"
708 exit 1"
709
710 cd $JHALFSDIR
711 case $PROGNAME in
712 clfs | clfs2 )
713 VERSION=$(xmllint --noent $BOOK/prologue/$ARCH/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
714 *)
715 VERSION=$(xmllint --noent $BOOK/prologue/bookinfo.xml 2>/dev/null | grep subtitle | sed -e 's/^.*ion //' -e 's/<\/.*//') ;;
716 esac
717
718 # Start clean
719 if [ -d ${PROGNAME}-commands ]; then
720 rm -rf ${PROGNAME}-commands
721 mkdir -v ${PROGNAME}-commands
722 fi
723 echo -n "Extracting commands for"
724
725 # Dump the commands in shell script form from the HLFS book.
726 case ${PROGNAME} in
727 clfs)
728 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
729 xsltproc --nonet \
730 --xinclude \
731 --stringparam method $METHOD \
732 --stringparam testsuite $TEST \
733 --stringparam vim-lang $VIMLANG \
734 --stringparam timezone $TIMEZONE \
735 --stringparam page $PAGE \
736 --stringparam lang $LANG \
737 --stringparam keymap $KEYMAP \
738 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
739 ;;
740
741 clfs2)
742 echo -n " ${L_arrow}${BOLD}$ARCH${R_arrow} target architecture"
743 xsltproc --nonet \
744 --xinclude \
745 --stringparam testsuite $TEST \
746 --stringparam vim-lang $VIMLANG \
747 --stringparam timezone $TIMEZONE \
748 --stringparam page $PAGE \
749 --stringparam lang $LANG \
750 --stringparam keymap $KEYMAP \
751 -o ./${PROGNAME}-commands/ $XSL $BOOK/$ARCH-index.xml >>$LOGDIR/$LOG 2>&1
752 ;;
753 hlfs)
754 echo -n " ${L_arrow}${BOLD}$MODEL${R_arrow} HLFS libc implementation"
755 xsltproc --nonet \
756 --xinclude \
757 --stringparam model $MODEL \
758 --stringparam testsuite $TEST \
759 --stringparam timezone $TIMEZONE \
760 --stringparam page $PAGE \
761 --stringparam lang $LANG \
762 --stringparam lc_all $LC_ALL \
763 --stringparam keymap $KEYMAP \
764 --stringparam grsecurity_host $GRSECURITY_HOST \
765 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
766 ;;
767 lfs)
768 echo -n " ${L_arrow}${BOLD}LFS${R_arrow} build"
769 xsltproc --nonet \
770 --xinclude \
771 --stringparam testsuite $TEST \
772 --stringparam vim-lang $VIMLANG \
773 --stringparam timezone $TIMEZONE \
774 --stringparam page $PAGE \
775 --stringparam lang $LANG \
776 -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
777 ;;
778 *) exit 1 ;;
779 esac
780
781 echo " ...OK"
782
783 # Make the scripts executable.
784 chmod -R +x $JHALFSDIR/${PROGNAME}-commands
785
786 # Create the packages file. We need it for proper Makefile creation
787 create_package_list
788
789 # Done. Moving on...
790 get_sources
791}
792
793#----------------------------#
794create_package_list() { #
795#----------------------------#
796
797 # Create the packages file. We need it for proper Makefile creation
798 rm -f pkg_tarball_list
799 echo -n "Creating <${PROGNAME}> list of tarball names for $BOOK $ARCH"
800 case ${PROGNAME} in
801 clfs | clfs2)
802 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
803 $BOOK/materials/${ARCH}-chapter.xml >>$LOGDIR/$LOG 2>&1
804 ;;
805 hlfs)
806 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
807 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
808 ;;
809 lfs)
810 xsltproc --nonet --xinclude -o pkg_tarball_list packages.xsl \
811 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
812 ;;
813 esac
814 echo " ...OK"
815
816}
817
818
819#----------------------------#
820get_sources() { # Download file, write name to MISSING_FILES.DMP if an error
821#----------------------------#
822 local saveIFS=$IFS
823 local IFS line URL1 URL2 FILE BOOKMD5 MD5 HAVEMD5 fromARCHIVE
824
825 # Test if the packages must be downloaded
826 [ ! "$GETPKG" = "1" ] && return
827
828 gs_wrt_message(){
829 echo "${RED}$1${OFF}"
830 echo "$1" >> MISSING_FILES.DMP
831 }
832 # Housekeeping
833 [[ ! -d $BUILDDIR/sources ]] && mkdir $BUILDDIR/sources
834 cd $BUILDDIR/sources
835 [[ -f MD5SUMS ]] && rm MD5SUMS
836 [[ -f MISSING_FILES.DMP ]] && rm MISSING_FILES.DMP
837 [[ -f urls.lst ]] && rm urls.lst
838
839 # Generate URLs file
840 create_urls
841
842 IFS=$'\x0A' # Modify the 'internal field separator' to break on 'LF' only
843 for line in `cat urls.lst`; do
844 IFS=$saveIFS # Restore the system defaults
845
846 # Skip some packages if they aren't needed
847 case $line in
848 */tcl* | */expect* | */dejagnu* | */tree* | */gcc-testsuite* )
849 [[ "$TEST" = "0" ]] && continue
850 ;;
851 */vim-*-lang* )
852 [[ "$VIMLANG" = "0" ]] && continue
853 ;;
854 *linux/linux-* )
855 [[ -z "$CONFIG" ]] && [[ -z "$BOOT_CONFIG" ]] && \
856 [[ "$GETKERNEL" = "0" ]] && continue
857 ;;
858 esac
859
860 # Locations
861 URL1=`echo $line | cut -d" " -f2` # Preferred URL
862 URL2=`echo $line | cut -d" " -f1` # Fallback Upstream URL
863 FILE=`basename $URL1` # File name
864 BOOKMD5=`echo $line | cut -d" " -f3` # MD5 book value
865
866 # Validation pair
867 MD5="$BOOKMD5 $FILE"
868 HAVEMD5=1
869
870 set -e
871 # If the file exists in the archive copy it to the
872 # $BUILDDIR/sources dir. MD5SUM will be validated later.
873 if [ ! -z ${SRC_ARCHIVE} ] &&
874 [ -d ${SRC_ARCHIVE} ] &&
875 [ -f ${SRC_ARCHIVE}/$FILE ]; then
876 cp ${SRC_ARCHIVE}/$FILE .
877 echo "$FILE: -- copied from $SRC_ARCHIVE"
878 fromARCHIVE=1
879 else
880 echo "${BOLD}${YELLOW}$FILE: not found in ${SRC_ARCHIVE}${OFF}"
881 fromARCHIVE=0
882 # If the file does not exist yet in /sources download a fresh one
883 if [ ! -f $FILE ] ; then
884 if ! wget $URL1 && ! wget $URL2 ; then
885 gs_wrt_message "$FILE not found in the SRC_ARCHIVE or on any server..SKIPPING"
886 continue
887 fi
888 fi
889 fi
890
891 # IF the md5sum does not match the existing files
892 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
893 [[ $fromARCHIVE = "1" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match SRC_ARCHIVE copy${OFF}"
894 [[ $fromARCHIVE = "0" ]] && echo "${BOLD}${YELLOW}MD5SUM did not match REMOTE copy${OFF}"
895 # Remove the old file and download a new one
896 rm -fv $FILE
897 # Force storage in SRC_ARCHIVE
898 fromARCHIVE=0;
899 # Try to retrieve again the file. Servers in reverse order.
900 if ! wget $URL2 && ! wget $URL1 ; then
901 gs_wrt_message "$FILE not found on the servers.. SKIPPING"
902 continue
903 fi
904 fi
905
906 # Validate the MD5SUM one last time
907 if ! echo "$MD5" | md5sum -c - >/dev/null ; then
908 gs_wrt_message "$FILE does not match MD5SUMS value"
909 # Force generation of MD5SUM
910 HAVEMD5=0
911 fi
912
913 # Generate a fresh MD5SUM for this file
914 if [[ "$HAVEMD5" = "0" ]] ; then
915 echo "${BOLD}${YELLOW}Generating a new MD5SUM for ${OFF}$FILE"
916 echo "NEW MD5SUM: $(md5sum $FILE)" >> MISSING_FILES.DMP
917 fi
918
919 # Good or bad we write the original md5sum to a file
920 echo "$MD5" >> MD5SUMS
921
922 # Copy the freshly downloaded file
923 # to the source archive.
924 if [ ! -z ${SRC_ARCHIVE} ] &&
925 [ -d ${SRC_ARCHIVE} ] &&
926 [ -w ${SRC_ARCHIVE} ] &&
927 [ "$fromARCHIVE" = "0" ] ; then
928 echo "Storing file:<$FILE> in the package archive"
929 cp -f $FILE ${SRC_ARCHIVE}
930 fi
931
932 done
933
934 if [[ -s MISSING_FILES.DMP ]]; then
935 echo -e "\n\n${tab_}${RED} One or more files were not retrieved or have a bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
936 # Do not allow the automatic exection of the Makefile.
937 echo "${tab_}${BOLD}${RED}*** ${YELLOW}Automatic execution of the generated makefile has been inhibited. ${RED}***${OFF}${nl_}"
938 RUNMAKE=0
939 fi
940}
941
942#----------------------------#
943create_urls() { #
944#----------------------------#
945 cd $JHALFSDIR
946
947 case ${PROGNAME} in
948 clfs)
949 echo -n "Creating CLFS <${ARCH}> specific URLs file"
950 xsltproc --nonet --xinclude \
951 --stringparam server $SERVER \
952 -o $BUILDDIR/sources/urls.lst urls.xsl \
953 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
954 echo " ...OK"
955 ;;
956 clfs2)
957 echo -n "Creating CLFS2 <${ARCH}> specific URLs file"
958 xsltproc --nonet --xinclude \
959 --stringparam server $SERVER \
960 -o $BUILDDIR/sources/urls.lst urls.xsl \
961 $BOOK/materials/$ARCH-chapter.xml >>$LOGDIR/$LOG 2>&1
962 echo " ...OK"
963 ;;
964 hlfs)
965 echo -n "Creating HLFS <${MODEL}> specific URLs file"
966 xsltproc --nonet --xinclude \
967 --stringparam server $SERVER \
968 --stringparam model $MODEL \
969 -o $BUILDDIR/sources/urls.lst urls.xsl \
970 $BOOK/chapter04/chapter04.xml >>$LOGDIR/$LOG 2>&1
971 echo " ...OK"
972 ;;
973 lfs)
974 echo -n "Creating LFS specific URLs file"
975 xsltproc --nonet --xinclude \
976 --stringparam server $SERVER \
977 -o ../sources/urls.lst urls.xsl \
978 $BOOK/chapter03/chapter03.xml >>$LOGDIR/$LOG 2>&1
979 echo " ...OK"
980 ;;
981 esac
982
983 cd $BUILDDIR/sources
984}
Note: See TracBrowser for help on using the repository browser.